Index: trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/src/G4Quasmon.cc
===================================================================
--- trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/src/G4Quasmon.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/src/G4Quasmon.cc	(revision 1055)
@@ -4611,51 +4647,52 @@
                     //********* ISOTOPIC  FOCUSING  *******************
                     // ==== Old (First Publication) Complicated rule ====
-				                //if(
-				                //  //zZ<3 &&
+                    //if(
+                    //  //zZ<3 &&
                     //  //(
-				                //  abs(dI)<1 ||
-				                //  (barot==1 && (
+                    //  abs(dI)<1 ||
+                    //  (barot==1 && (
                     //     abs(dI)<2&&abs(cC-charge)<2 ||
-				                //     (dI>=2&&cC<charge)   || (dI<=-2&&cC>charge)
+                    //     (dI>=2&&cC<charge)   || (dI<=-2&&cC>charge)
                     //     //dI==2&&cC<=charge || dI==-2&&cC>=charge ||
                     //     //dI>2&&cC<charge   || dI<-2&&cC>charge
-				                //   )) || 
-				                //   (barot>1&&barot<3
-				                //     && (
-				                //     abs(dI)<2&&abs(cC-charge)<2 ||
+                    //   )) || 
+                    //   (barot>1&&barot<3
+                    //     && (
+                    //     abs(dI)<2&&abs(cC-charge)<2 ||
                     //     //dI>=2&&cC<charge   || dI<=-2&&cC>charge
-				                //     dI<=2&&cC<=charge || dI==-2&&cC>=charge ||
-				                //     dI>2&&cC<charge   || dI<-2&&cC>charge
-				                //   )) ||
-				                //   (barot>2&&barot<4
-				                //    && (
-				                //     abs(dI)<2&&abs(cC-charge)<2 ||
+                    //     dI<=2&&cC<=charge || dI==-2&&cC>=charge ||
+                    //     dI>2&&cC<charge   || dI<-2&&cC>charge
+                    //   )) ||
+                    //   (barot>2&&barot<4
+                    //    && (
+                    //     abs(dI)<2&&abs(cC-charge)<2 ||
                     //     //dI>=2&&cC<charge   || dI<=-2&&cC>charge
-				                //     dI<=2&&cC<=charge || dI==-3&&cC>=charge ||
-				                //     dI>2&&cC<charge   || dI<-3&&cC>charge
-				                //   )) ||
-				                //   (barot>3
-				                //    && (
-				                //     abs(dI)<2&&abs(cC-charge)<2 ||
+                    //     dI<=2&&cC<=charge || dI==-3&&cC>=charge ||
+                    //     dI>2&&cC<charge   || dI<-3&&cC>charge
+                    //   )) ||
+                    //   (barot>3
+                    //    && (
+                    //     abs(dI)<2&&abs(cC-charge)<2 ||
                     //     dI>=2&&cC<charge   || dI<=-2&&cC>charge
-				                //     //dI<=2&&cC<=charge || dI==-3&&cC>=charge ||
-				                //     //dI>2&&cC<charge   || dI<-3&&cC>charge
-				                //    )
+                    //     //dI<=2&&cC<=charge || dI==-3&&cC>=charge ||
+                    //     //dI>2&&cC<charge   || dI<-3&&cC>charge
+                    //    )
                     //   )
-				                //  )
+                    //  )
                     // ==== Just a coridor =======
-	      					//if(abs(dS)<3||(qIso>0&&dC<0||qIso<0&&dC>0)&&baryn==1)//StrForB=1(old)
-				                //if(abs(dS)<4||(qIso>0&&dC<0||qIso<0&&dC>0)&&baryn==1)//StrongFor1(<4)
-				                //if(baryn>1||abs(dS)<4||(qIso>0&&dC<0||qIso<0&&dC>0)&&baryn==1)//SIFF1
-				                //if(!piF&&abs(dS)<4 || piF&&abs(dS)<3) // UniversalIsoFocusing
-				                //if(!piF&&first&&abs(dS)<4 || (!piF&&!first||piF)&&abs(dS)<3)//ExpIsoF
-
-		    if ( (!piF && first && baryn < 3) || 
-                         (!piF && !first) || 
-                         (piF && abs(dS) < 3) ) 
-                                                // ExpIsoFoc
-				                //if(!qIso&&!dC||qIso>0&&dC<0||qIso<0&&dC>0)//MediumIsoFocusingForAll
-				                //if(abs(dS)<3) // Universal IsotopeFocusing(<3) (Best for pi-capture)
-				                //if(abs(dS)<4) // Never try this (**)
+                    //if(abs(dS)<3||(qIso>0&&dC<0||qIso<0&&dC>0)&&baryn==1)//StrForB=1(old)
+                    //if(abs(dS)<4||(qIso>0&&dC<0||qIso<0&&dC>0)&&baryn==1)//StrongFor1(<4)
+                    //if(baryn>1||abs(dS)<4||(qIso>0&&dC<0||qIso<0&&dC>0)&&baryn==1)//SIFF1
+                    //if(!piF&&abs(dS)<4 || piF&&abs(dS)<3) // UniversalIsoFocusing
+                    //if(!piF&&first&&abs(dS)<4 || (!piF&&!first||piF)&&abs(dS)<3)//ExpIsoF
+                    // *** Recent correction (****
+                    //if ( (!piF && first && baryn < 3) || 
+                    //     (!piF && !first) || 
+                    if ( (!piF && first && baryn < 3) || 
+                         (!piF && !first && baryn < 5 ) || 
+                         (piF && abs(dS) < 3) ) // Isotopic focusing for AtRest Reactions
+                    //if(!qIso&&!dC||qIso>0&&dC<0||qIso<0&&dC>0)//MediumIsoFocusingForAll
+                    //if(abs(dS)<3) // Universal IsotopeFocusing(<3) (Best for pi-capture)
+                    //if(abs(dS)<4) // Never try this (**)
                     //if(3>2)       //***>>> ***NO*** Isotope Focusing ***
                     {
@@ -4674,5 +4711,6 @@
                       else if(resPDG)minM=G4QPDGCode(resPDG).GetMass();//ResidQuasmonHadron
                       G4double bNM2=nucBM*nucBM;
-                      G4double nDelta=(frM2-bNM2)/(nucBM+nucBM);
+                      G4double nDelta=0.;
+                      if(nucBM)nDelta=(frM2-bNM2)/(nucBM+nucBM);    // Safety check
 #ifdef pdebug
                       G4int    iniPDG =valQ.GetSPDGCode();
@@ -4683,5 +4721,5 @@
                                       <<kCut<<",E="<<E<<">"<<nDelta<<",p="<<parPDG<<G4endl;
 #endif
-					                 if(resPDG&&minM>0.) // Kinematical analysis of hadronization
+                      if(resPDG&&minM>0.) // Kinematical analysis of hadronization
                       {
 #ifdef pdebug
@@ -4738,12 +4776,11 @@
                         //if(envM>boundM)
                         if ( (envA-barot <= bEn && envM > boundM) || envA-barot > bEn)
-  			       //if(2>3)
+                        //if(2>3)        // *** Recent correction ***
                         {
                           minBM=rtM;
                           // *** LIM ***
-                          if(envA-barot>bEn) minBM-=mbEn;
-                          else
-                            minBM-=envM-boundM; // MinResidualBoundedQuasmonMass
-					                   }
+                          if(envA-barot > bEn) minBM-=mbEn;
+                          else         minBM-=envM-boundM; // MinResidualBoundedQuasmonMass
+                        }
                         G4double minBM2=minBM*minBM+.1;
                         G4double minM2=minM*minM+.1;
@@ -4754,20 +4791,20 @@
                                          <<(mintM2-rtQ2)/rtEP/2<<G4endl;
 #endif
-					                   G4double newh=1.;
+                        G4double newh=1.;
                         // == (@@) Historical additional cuts for q_min ===
                         //G4double nc=1.-(dkLS-E-E)/boundM;   // q_min=k-E
                         G4double nc=1.-(dkLS-E-E+CB+CB)/boundM;   // q_min=k-E+CB
-					                   G4double newl=0.;
+                        G4double newl=0.;
 #ifdef pdebug
                         if(pPrint) G4cout<<"G4Q::CHP:qi_k-E="<<nc<<",k="<<kLS<<",E="<<E
                                          <<",M="<<boundM<<G4endl;
 #endif
-                        if(nc>0.&&nc<1.&&nc<ne)
+                        if(nc > 0. && nc < 1. && nc < ne)
                         {
                           ne=nc;
                           newh=pow(nc,cNQ);
-                          if(newh<kf) kf=newh;
+                          if(newh < kf) kf=newh;
                         }
-                        else if(nc<=0.)kf=0.;
+                        else if(nc <= 0.) kf=0.;
 
                         //G4double nk=1.-(dkd-Em-Em)/boundM;  // q_min=(k-delta)-E*(M-m)/M
@@ -4776,5 +4813,5 @@
                         //               <<",M="<<totMass<<G4endl;
 #endif
-                        //if(nk>0.&&nk<1.&&nk<ne)
+                        //if(nk > 0. && nk < 1. && nk < ne)
                         //{
                         //  ne=nk;
@@ -4782,5 +4819,5 @@
                         //  if(newh<kf) kf=newh;
                         //}
-                        //else if(nk<=0.)kf=0.;
+                        //else if(nk <= 0.) kf=0.;
 
                         //G4double mex=frM+Em;
@@ -4791,5 +4828,5 @@
                         //                <<",M="<<frM<<G4endl;
 #endif
-                        //if(np>0.&&np<1.&&np<ne)
+                        //if(np > 0. && np < 1. && np < ne)
                         //{
                         //  ne=np;
@@ -4797,5 +4834,5 @@
                         //  if(newh<kf) kf=newh;
                         //}
-                        //else if(np<=0.)kf=0.;
+                        //else if(np <= 0.) kf=0.;
 
                         //G4double mix=boundM+E;
@@ -4804,5 +4841,5 @@
                         ////G4double mix=nucBM+E-CB;
                         G4double st=0.;
-                        if(mix>frM) st=sqrt(mix*mix-frM2);
+                        if(mix > frM) st=sqrt(mix*mix-frM2);
                         G4double nq=1.-(dkLS-st-st)/boundM;//qi=k-sq((m+E*(M-m)/M)^2-m^2)
 #ifdef pdebug
@@ -4810,10 +4847,10 @@
                                          <<mix<<",M="<<frM<<G4endl;
 #endif
-                        if(nq>0.&&nq<1.&&nq<ne)
-																								//if(2>3)  // Does not make any difference
+                        if(nq > 0. && nq < 1. && nq < ne)
+                        //if(2>3)  // Does not make any difference
                         {
                           ne=nq;
                           newh=pow(nq,cNQ);
-                          if(newh<kf) kf=newh;
+                          if(newh < kf) kf=newh;
                         }
                         else if(nq<=0.)kf=0.;
@@ -4825,11 +4862,11 @@
                         //G4bool atrest=(eQ-mQ)/mQ<.001; // Q at rest (only PiCap)
                         // ***VTN*** CHECK IsNecessety toRecover theColTotRes to MinMassTot
-					                   if(mintM2>rtQ2) //==> Check of ResidualTotalNucleus ** Always **
-																								//if(2>3)  // Negligable difference difference
+                        if(mintM2>rtQ2) //==> Check of ResidualTotalNucleus ** Always **
+                        //if(2>3)  // Negligable difference difference
                         {
                           G4double nz=0.;
-						                    if(atrest) nz=1.-(mintM2-rtQ2+pmk*dked)/(boundM*(rtEP+pmk));
+                          if(atrest) nz=1.-(mintM2-rtQ2+pmk*dked)/(boundM*(rtEP+pmk));
                           else       nz=1.-(mintM2-rtQ2)/(boundM*rtEP);
-						                    //if(atrest) nz=1.-(mintM2-rtQ2+pmk*dkd)/(nucBM*(rtEP+pmk));
+                          //if(atrest) nz=1.-(mintM2-rtQ2+pmk*dkd)/(nucBM*(rtEP+pmk));
                           //else       nz=1.-(mintM2-rtQ2)/(nucBM*rtEP);
 #ifdef pdebug
@@ -4837,41 +4874,44 @@
                                            <<mintM2<<">"<<rtQ2<<G4endl;
 #endif
-                          if(nz>0.&&nz<1.&&nz<ne)
+                          if(nz > 0. && nz < 1. && nz < ne)
                           {
                             ne=nz;
                             newh=pow(nz,cNQ);
-                            if(newh<kf) kf=newh;
+                            if(newh < kf) kf=newh;
                           }
-                          else if(nz<=0.)kf=0.;
+                          else if(nz <= 0.) kf=0.;
                         }
                         // *** VBQ *** CHECK Residual Quazmon (Never use: reduces PS)
-					                   //if(minBM2>rQ2&&!piF&&!gaF&&baryn>3) // ==>Check ResidVirtualQuasm
-					                   //if(minBM2>rQ2&&!piF&&!gaF&&baryn>2) // ==>Check ResidVirtualQuasm
+                        //if(minBM2>rQ2&&!piF&&!gaF&&baryn>3) // ==>Check ResidVirtualQuasm
+                        //if(minBM2>rQ2&&!piF&&!gaF&&baryn>2) // ==>Check ResidVirtualQuasm
                         //if(minBM2>rQ2&&!piF&&!gaF) // ==> Check of ResidualVirtualQuasmon
-					                   //if(minBM2>rQ2&&baryn>2)//==>Check of ResidualVirtualQuasmon**OK**
-					                   //if(minBM2>rQ2&&baryn>1)//==>Check ResidualVirtualQuasm **Better**
-					                   //if(minBM2>rQ2&&piF&&(cPDG==90000001||cPDG==90002002))//CheckRVirQ
-					                   //if(minBM2>rQ2&&piF&&(cPDG==90000001||baryn>3))//CheckResidVirtQua
-					                   //if(minBM2>rQ2&&(piF&&cPDG==90000001||baryn>2))//CheckResidVirtQua
-					                   //if(minBM2>rQ2&&baryn>2) // ==> Check of Residual Virtual Quasmon
-					                   //if(minBM2>rQ2&&!piF&&baryn>2&&cPDG!=90001002)//ResidVirtQuasmon
-					                   //if(minBM2>rQ2&&!piF&&baryn>2)//==>Check of ResidualVirtualQuasmon
-					                   //if(minBM2>rQ2&&!piF&&baryn>3)//==>Check of ResidualVirtualQuasmon
-					                   //if(minBM2>rQ2&&!piF&&baryn>1)//==>Check of ResidualVirtualQuasmon
-					                   //if(minBM2>rQ2&&!piF&&!gaF)// ==> Check of ResidualVirtualQuasmon
-					                   //if(minBM2>rQ2&&!piF)// ==> Check of ResidualVirtualQuasmon ALWAYS
-					                   //if(minBM2>rQ2&&piF&&baryn>3)//==>Check of ResidualVirtualQuasmon
-					                   //if(minBM2>rQ2&&piF&&(baryn==1||baryn>2))//==>Check ResidVirtQ
-					                   //if(minBM2>rQ2&&(!piF||piF&&(cPDG!=90000001||G4UniformRand()<.5)))
-					                   //if(minBM2>rQ2&&(!piF||piF&&(cPDG!=90000001)))
+                        //if(minBM2>rQ2&&baryn>2)//==>Check of ResidualVirtualQuasmon**OK**
+                        //if(minBM2>rQ2&&baryn>1)//==>Check ResidualVirtualQuasm **Better**
+                        //if(minBM2>rQ2&&piF&&(cPDG==90000001||cPDG==90002002))//CheckRVirQ
+                        //if(minBM2>rQ2&&piF&&(cPDG==90000001||baryn>3))//CheckResidVirtQua
+                        //if(minBM2>rQ2&&(piF&&cPDG==90000001||baryn>2))//CheckResidVirtQua
+                        //if(minBM2>rQ2&&baryn>2) // ==> Check of Residual Virtual Quasmon
+                        //if(minBM2>rQ2&&!piF&&baryn>2&&cPDG!=90001002)//ResidVirtQuasmon
+                        //if(minBM2>rQ2&&!piF&&baryn>2)//==>Check of ResidualVirtualQuasmon
+                        //if(minBM2>rQ2&&!piF&&baryn>3)//==>Check of ResidualVirtualQuasmon
+                        //if(minBM2>rQ2&&!piF&&baryn>1)//==>Check of ResidualVirtualQuasmon
+                        //if(minBM2>rQ2&&!piF&&!gaF)// ==> Check of ResidualVirtualQuasmon
+                        //if(minBM2>rQ2&&!piF)// ==> Check of ResidualVirtualQuasmon ALWAYS
+                        //if(minBM2>rQ2&&piF&&baryn>3)//==>Check of ResidualVirtualQuasmon
+                        //if(minBM2>rQ2&&piF&&(baryn==1||baryn>2))//==>Check ResidVirtQ
+                        //if(minBM2>rQ2&&(!piF||piF&&(cPDG!=90000001||G4UniformRand()<.5)))
+                        //if(minBM2>rQ2&&(!piF||piF&&(cPDG!=90000001)))
                         //if(minBM2>rQ2&&(!piF&&baryn>4 || piF && cPDG!=90000001 &&
-		   	if (minBM2 > rQ2 && 
-                            (!piF || 
-                            (piF && 
-                             cPDG != 90000001 && 
-                             cPDG != 90001001 && 
-                             cPDG != 90001002) ) )      
-                                                           //if(minBM2>rQ2) // ==> Check of Residual (Virtual?) Quasmon
-			      				   //if(2>3)
+                        if (minBM2 > rQ2 && 
+                             ( !piF || 
+                               ( piF
+                                 && cPDG != 90000001
+                                 &&  cPDG != 90001001
+                                 &&  cPDG != 90001002
+                               )
+                             )
+                           )      
+                        //if(minBM2>rQ2) // ==> Check of Residual (Virtual?) Quasmon
+                        //if(2>3)
                         {
                           G4double nz=0.;
@@ -4880,8 +4920,8 @@
                           //if(atrest) nz=1.-(minBM2-rQ2+pmk*dkd)/(nucBM*(rEP+pmk));
                           //else       nz=1.-(minBM2-rQ2)/(nucBM*rEP);
-#ifdef pdebug		  
+#ifdef pdebug    
                           if(pPrint) G4cout<<"G4Q::CHP:q="<<nz<<",a="<<atrest<<",QM2="
                                            <<minM2<<">"<<rQ2<<G4endl;
-#endif				  
+#endif      
                           if(nz>0.&&nz<1.&&nz<ne)
                           {
@@ -4893,29 +4933,29 @@
                         }
                         // *** VRQ *** CHECK Min Residual Quazmon (Never use: reduces PS)
-					                   //if(minM2>rQ2&&baryn>3)       // ==> Check of Residual Quasmon
-					                   //if(minM2>rQ2&&!piF&&!gaF&&baryn>3)// ==> Check of ResidualQuasmon
-					                   //if(minM2>rQ2&&!piF&&baryn>1)      // ==> Check of ResidualQuasmon
-					                   //if(minM2>rQ2&&!piF&&baryn>2)      // ==> Check of ResidualQuasmon
-					                   //if(minM2>rQ2&&!piF&&baryn>2&&cPDG!=90001002)//=>CheckResidQuasmon
-					                   //if(minM2>rQ2&&!piF&&baryn>3) // ==> Check Residual Quasmon **OK**
-					                   //if(minM2>rQ2&&!piF&&!gaF)       // ==> Check of Residual Quasmon
-					                   //if(minM2>rQ2&&!piF)       // ==> Check of Residual Quasmon
-					                   //if(minM2>rQ2&&piF)       // ==> Check of Residual Quasmon
-					                   //if(minM2>rQ2&&baryn>1) // ==> Check Residual Quasmon **Better**
-					                   //if(minM2>rQ2&&(baryn>1||!piF))//==>CheckResidualQuasmon**Better**
-					                   //if(minM2>rQ2&&baryn>1&&cPDG!=90002002) //==> CheckResidualQuasmon
-					                   //if(minM2>rQ2&&!piF) // ==> Check of Residual Quasmon
-					                   //if(minM2>rQ2&&baryn>3) //=>CheckResidQuasmon *** The Best ***
-					                   //if(minM2>rQ2 && (!piF || piF &&
+                        //if(minM2>rQ2&&baryn>3)       // ==> Check of Residual Quasmon
+                        //if(minM2>rQ2&&!piF&&!gaF&&baryn>3)// ==> Check of ResidualQuasmon
+                        //if(minM2>rQ2&&!piF&&baryn>1)      // ==> Check of ResidualQuasmon
+                        //if(minM2>rQ2&&!piF&&baryn>2)      // ==> Check of ResidualQuasmon
+                        //if(minM2>rQ2&&!piF&&baryn>2&&cPDG!=90001002)//=>CheckResidQuasmon
+                        //if(minM2>rQ2&&!piF&&baryn>3) // ==> Check Residual Quasmon **OK**
+                        //if(minM2>rQ2&&!piF&&!gaF)       // ==> Check of Residual Quasmon
+                        //if(minM2>rQ2&&!piF)       // ==> Check of Residual Quasmon
+                        //if(minM2>rQ2&&piF)       // ==> Check of Residual Quasmon
+                        //if(minM2>rQ2&&baryn>1) // ==> Check Residual Quasmon **Better**
+                        //if(minM2>rQ2&&(baryn>1||!piF))//==>CheckResidualQuasmon**Better**
+                        //if(minM2>rQ2&&baryn>1&&cPDG!=90002002) //==> CheckResidualQuasmon
+                        //if(minM2>rQ2&&!piF) // ==> Check of Residual Quasmon
+                        //if(minM2>rQ2&&baryn>3) //=>CheckResidQuasmon *** The Best ***
+                        //if(minM2>rQ2 && (!piF || piF &&
                         //if(minM2>rQ2 && (!piF&&baryn>3 || piF &&
-
-			if (minM2 > rQ2 && 
-                            ( (!piF && baryn > 4) || 
-                              (piF &&
-                              (cPDG != 90000001 || G4UniformRand() > .3333333) && 
-			       cPDG != 90001001) ) )
-                            //cPDG!=90001001) )
-			    //if(minM2>rQ2)            // ==> Check of Residual Quasmon
-			    //if(2>3)
+                        if ( minM2 > rQ2 && 
+                             ( (!piF && baryn > 4) || 
+                               (piF && (cPDG != 90000001 || G4UniformRand() > .3333333) && 
+                                cPDG != 90001001)
+                             )
+                           )
+                        //cPDG!=90001001) )
+                        //if(minM2>rQ2)            // ==> Check of Residual Quasmon
+                        //if(2>3)
                         {
                           G4double nz=0.;
@@ -5072,30 +5112,30 @@
                         curParC->SetNQPart2(cNQ);  // Keep #of quark-partons in theFragment
 #ifdef sdebug
-		 	                    G4cout<<"G4Q::CalcHP: FillParentClaster="<<*curParC<<G4endl;
+                        G4cout<<"G4Q::CalcHP: FillParentClaster="<<*curParC<<G4endl;
 #endif
                         curCand->FillPClustVec(curParC);//FillParentClust to ParClVec(d.e.)
                         comb += probab;
 #ifdef pdebug
-		 	                    if(pPrint) G4cout<<"G4Q::CHP:in="<<index<<",cPDG="<<cPDG<<",pc"<<pc
+                        if(pPrint) G4cout<<"G4Q::CHP:in="<<index<<",cPDG="<<cPDG<<",pc"<<pc
                                          <<parQC<<",Env="<<theEnvironment<<",comb="<<comb
                                          <<",posib="<<parCand->GetParPossibility()<<G4endl;
 #endif
                         pc++;
-					                 }
-				                }
+                      }
+                    }
 #ifdef sdebug
-				                else G4cout<<"***G4Q::CHP:dI="<<dI<<",cC="<<cC<<G4endl;
-#endif
-				              }
-			             }                             // >>>> End of if of QuarkExchangePossibility
-			           }                               // +++> End of if of existinr residual Q Code
+                    else G4cout<<"***G4Q::CHP:dI="<<dI<<",cC="<<cC<<G4endl;
+#endif
+                  }
+                }                             // >>>> End of if of QuarkExchangePossibility
+              }                               // +++> End of if of existinr residual Q Code
               probability+=comb;              // Collect the probability for the fragment
 #ifdef pdebug
-	 	           if(pPrint) G4cout<<"G4Q::CHPr: probab="<<probability<<"("<<comb<<"),iq="<<iq
+              if(pPrint) G4cout<<"G4Q::CHPr: probab="<<probability<<"("<<comb<<"),iq="<<iq
                                <<",oq="<<oq<<G4endl;
 #endif
-		          }                                 // ...> End of Quark Exchange "oq" Test LOOP
-		        }                                   // ...> End of Quark Exchange "iq" Test LOOP
-	       }                                     // ---> End of Nuclear Case of fragmentation
+            }                                 // ...> End of Quark Exchange "oq" Test LOOP
+          }                                   // ...> End of Quark Exchange "iq" Test LOOP
+        }                                     // ---> End of Nuclear Case of fragmentation
         else if(cPDG<80000000)                // ===> Hadron case (QUark FUsion mechanism)
         {
@@ -5111,6 +5151,6 @@
             if (curhPDG== 211) npip++;
             if (curhPDG==-211) npin++;
-		        }
-		        // End of the hadron counting
+          }
+          // End of the hadron counting
           comb = valQ.NOfCombinations(candQC);
           if(!comb)
@@ -5163,5 +5203,5 @@
           if (comb && resPDG && totMass > frM-CB+resTM &&
              ((resPDG > 80000000 && resPDG != 90000000) || resPDG<10000) )
-	  {
+   {
 #ifdef pdebug
             if(priCon) G4cout<<"G4Q::CHP:ind="<<index<<",qQC="<<valQ<<mQ<<",cPDG="<<cPDG
@@ -5196,5 +5236,5 @@
 #endif
             if(resM>0. && resQCode>-2)
-	           {
+            {
               G4double limM=mQ-resM;
               G4double rndM=GetRandomMass(cPDG,limM);// Candidate's Mass randomization
@@ -5202,11 +5242,11 @@
               G4double cMass=G4QPDGCode(cPDG).GetMass();
               if(aPDG<10000&&aPDG%10<3)
-			           //if(aPDG<10000&&aPDG%10<5)
-			           G4cout<<"G4Q::CHP:rndM="<<rndM<<",limM="<<limM<<" > cM="<<cMass<<" ,rM+fM="
+              //if(aPDG<10000&&aPDG%10<5)
+              G4cout<<"G4Q::CHP:rndM="<<rndM<<",limM="<<limM<<" > cM="<<cMass<<" ,rM+fM="
                     <<resM+rndM<<" < mQ="<<mQ<<G4endl;
 #endif
               // --- Kinematical Factors ---
               if(rndM>0. && resM+rndM<mQ)
-	             {
+              {
                 curCand->SetEBMass(rndM);   // Set RandomizedEnvBoundMass of the Candidate
                 curCand->SetNBMass(rndM);   // Set RandomizedNotBoundMass of the Candidate
@@ -5219,5 +5259,5 @@
                 //zMin= mR2/mQ/(mQ-dk);       // z_min for Quasmon-Baryon @@ ?? @@
                 if(qBar) zMin= mR2/mQ/(mQ-dk);       // z_min for Quasmon-Baryon @@ ?? @@
-			             G4double possibility=zMax-zMin;
+                G4double possibility=zMax-zMin;
 #ifdef pdebug
                 if(priCon) G4cout<<"G4Q::CHP:M="<<rndM<<",ps="<<possibility<<",zMax="<<zMax
@@ -5226,10 +5266,10 @@
 #endif
                 if (resPDG==10)                      // Chipolino case - check minimum
-		              {
+                {
                   G4double rM2 = mQk*(mQ-rHk);
                   if(rM2<resM*resM) possibility = 0.;
                 }
                 if (possibility>0. && vap>0 && zMax>zMin)
-	               {
+                {
                   probability = vaf*(pow(zMax, vap)-pow(zMin, vap));
 #ifdef pdebug
@@ -5249,10 +5289,10 @@
                   {
                     if(cPDG==110||cPDG==220||cPDG==330) probability*=comb; // f0 has spin 0
-			                 else probability*=comb*(abs(cPDG)%10); // Spin of resonance
-				              }
-	               }
+                    else probability*=comb*(abs(cPDG)%10); // Spin of resonance
+                  }
+                }
               }
               else
-		            {
+              {
 #ifdef pdebug
                 if(priCon) G4cout<<"G4Q::CHP:cM=0[cPDG"<<cPDG<<"],mQ/QC="<<mQ<<valQ<<",rM="
@@ -5260,15 +5300,15 @@
 #endif
               }
-	           }
+            }
             else
-	           {
+            {
 #ifdef pdebug
               if(priCon) G4cout<<"***G4Q::CHP: M=0, #"<<index<<valQ<<",cPDH="<<cPDG<<"+rP="
                                <<resPDG<<curQ<<G4endl;
 #endif
-	           }
+            }
           }
           else
-	         {
+          {
             probability=0.;
 #ifdef pdebug
@@ -5277,5 +5317,5 @@
                              <<"+rTM="<<resTM<<"-CB="<<CB<< G4endl;
 #endif
-	         }
+          }
           //if(cPDG==111) secondProbab = 1.;
         }// ---> End of Hadronic Case of fragmentation
@@ -5344,27 +5384,27 @@
 #endif
     if(bsCond)                           // Decay rignht away in Fragment & residual
-	   {
+    {
       G4QContent fragmQC=protQC;
-	     G4double fragmM=mProt;
+      G4double fragmM=mProt;
       if(bsCond==2112)
-	     {
+      {
         fragmQC=neutQC;
-	       fragmM=mNeut;
-	     }
+        fragmM=mNeut;
+      }
       else if(bsCond==3122)
-	     {
+      {
         fragmQC=lambQC;
-	       fragmM=mLamb;
-	     }
+        fragmM=mLamb;
+      }
       else if(bsCond==90001001)
-	     {
+      {
         fragmQC=deutQC;
-	       fragmM=mDeut;
-	     }
+        fragmM=mDeut;
+      }
       else if(bsCond==90002002)
-	     {
+      {
         fragmQC=alphQC;
-	       fragmM=mAlph;
-	     }
+        fragmM=mAlph;
+      }
       G4QContent rsQC=valQ-fragmQC;
       G4QNucleus rsQN(rsQC);              // TemporaryNucleus for the ResidualVacuumQuasmon
@@ -5381,10 +5421,10 @@
         FillHadronVector(fragH);          // Fill ResidQuasmHadron (delete equivalent)
         return true;
-	     }
+      }
       else
-	     {
+      {
         delete quasH;
         delete fragH;
-	     }
+      }
     }
   }
@@ -5402,10 +5442,10 @@
     G4QHadron*  theLast = theQHadrons[nOfOUT-1];
     if(!(theLast->GetNFragments()) && theLast->GetPDGCode()!=22)//NotDecayedHadron & NotGam
-	   {
+    {
       G4LorentzVector hadr4M=theLast->Get4Momentum();
       G4double  hadrMa=hadr4M.m();        // Mass of the Last hadron (==GSMass)
       G4LorentzVector tmpTLV=reTLV+hadr4M;// Tot (ResidNucl+LastHadron) 4-Mom
 #ifdef pdebug
-	     G4cout<<"G4Q::CheckGS:YES,T="<<tmpTLV<<tmpTLV.m()<<">rM+hM="<<resSMa+hadrMa<<G4endl;
+      G4cout<<"G4Q::CheckGS:YES,T="<<tmpTLV<<tmpTLV.m()<<">rM+hM="<<resSMa+hadrMa<<G4endl;
 #endif
       if(tmpTLV.m()>resSMa+hadrMa)        // resMa contains 2 Hadrons: resQ and Environ
@@ -5430,6 +5470,6 @@
             FillHadronVector(quasH);              // Fill ResidQuasm Hadron (del.equiv.)
             theLast->Set4Momentum(hadr4M);
-		        }
-	       }
+          }
+        }
         else                                      //=>"The Env is vacuum" case (DecayIn2)
         {
@@ -5448,11 +5488,11 @@
             quasH->Set4Momentum(quas4M);
             FillHadronVector(quasH);              // Fill ResidQuasmHadron (del.equivalent)
-		        }
-	       }
+          }
+        }
       }
       else                                        // "CORRECTION" !!!!
       {
         if(nOfOUT>1 && corFlag)
-	       {
+        {
           G4QHadron*  thePrev = theQHadrons[nOfOUT-2];// Get pointer to prev-before-lastHad
           if(thePrev->GetNFragments()||thePrev->GetPDGCode()==22)return false;//DecH or Gam
@@ -5465,5 +5505,5 @@
           G4double   totNMa=tmpTLV.m();                   // RealMass of TotResidualNucleus
 #ifdef pdebug
-	         G4cout<<"G4Q::CheckGS:NO, M="<<tmpTLV<<totNMa<<">"<<totQMa+hadrMa+prevMa<<G4endl;
+          G4cout<<"G4Q::CheckGS:NO, M="<<tmpTLV<<totNMa<<">"<<totQMa+hadrMa+prevMa<<G4endl;
 #endif
           if(totNMa>totQMa+hadrMa+prevMa)
@@ -5484,10 +5524,10 @@
               thePrev->Set4Momentum(prev4M);
 #ifdef pdebug
-	          G4cout<<"G4Q::CheckGS: Yes, Check D4M="<<tmpTLV-hadr4M-prev4M-nuc4M<<G4endl;
-#endif
-	           }
-		        }
+           G4cout<<"G4Q::CheckGS: Yes, Check D4M="<<tmpTLV-hadr4M-prev4M-nuc4M<<G4endl;
+#endif
+            }
+          }
           else                                         // Decay in one hadron, absorb other
-		        {
+          {
             G4QContent tmpLNQ=totQC+thePrev->GetQC();
             G4int    resLPDG =tmpLNQ.GetSPDGCode();
@@ -5498,9 +5538,9 @@
             //////G4bool    which = true;          // LastH is absorbed, PrevH is radiated
 #ifdef pdebug
-	           G4cout<<"G4Quasm::CheckGS: NO, tM="<<totNMa<<" > rp+l="<<resLastM+hadrMa
+            G4cout<<"G4Quasm::CheckGS: NO, tM="<<totNMa<<" > rp+l="<<resLastM+hadrMa
                   <<" || > rl+p="<<resPrevM+prevMa<<G4endl;
 #endif
             if      (totNMa>resLastM+hadrMa)       // "Just exclude the Prev" case
-		          {
+            {
               theQHadrons.pop_back();              // theLast* is excluded from OUTPUT HV
               theQHadrons.pop_back();              // thePrev* is excluded from OUTPUT HV
@@ -5511,10 +5551,10 @@
               resPrevM=resLastM;
               prev4M  = hadr4M;
-		          }
+            }
             else if (totNMa>resPrevM+prevMa)              // "Just exclude the Last" case
-		          {
+            {
               theQHadrons.pop_back();
               delete theLast;
-		          }
+            }
             else return false;
             G4LorentzVector nuc4M = G4LorentzVector(0.,0.,0.,resPrevM);//ResNucl4m to PrevH
